package com.huimv.video.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.video.entity.CameraArea;
import com.huimv.video.service.ICameraAreaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2021-09-13
 */
@RestController
@RequestMapping("/cameraArea")
public class CameraAreaController {
    @Autowired
    private ICameraAreaService cameraAreaService;

    @PostMapping("/list")
    public Result list(@RequestBody Map<String, Object> params){
      return   cameraAreaService.cameraList(params);
    }

    @PostMapping("/add")
    public Result add(@RequestBody CameraArea cameraArea){
        int brandName = cameraAreaService.count(new QueryWrapper<CameraArea>().eq("area_name", cameraArea.getAreaName()));
        if (brandName >0){
            return new Result(ResultCode.FAIL,"该区域已经存在");
        }
        cameraAreaService.save(cameraArea);
        return new Result(10000,"添加成功",true);
    }

    @PostMapping("/update")
    public Result update(@RequestBody CameraArea cameraArea){
        cameraAreaService.updateById(cameraArea);
        return new Result(10000,"修改成功",true);
    }

    @GetMapping("/remove")
    public Result remove( @RequestParam(value = "ids") List<Integer> ids){

        return cameraAreaService.removeIds(ids);

    }

}
