package com.huimv.video.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.video.entity.CameraBrand;
import com.huimv.video.service.ICameraBrandService;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2021-09-13
 */
@RestController
@RequestMapping("/cameraBrand")
public class CameraBrandController {

    @Autowired
    private ICameraBrandService cameraBrandService;

    @PostMapping("/list")
    public Result list(@RequestBody Map<String, Object> params){
        return   cameraBrandService.listPage(params);
    }

    @PostMapping("/add")
    public Result add(@RequestBody CameraBrand cameraBrand){
        int brandName = cameraBrandService.count(new QueryWrapper<CameraBrand>().eq("brand_name", cameraBrand.getBrandName()));
        if (brandName >0){
            return new Result(ResultCode.FAIL,"该品牌名称已经存在");
        }

        cameraBrandService.save(cameraBrand);
        return new Result(ResultCode.SUCCESS,"添加成功");
    }

    @PostMapping("/update")
    public Result update(@RequestBody CameraBrand cameraArea){
        cameraBrandService.updateById(cameraArea);
        return new Result(ResultCode.SUCCESS,"修改成功");
    }

    @GetMapping("/remove")
    public Result remove(@RequestParam(value = "ids") List<Integer> ids){
        return cameraBrandService.removeIds(ids);
    }

}
