package com.huimv.video.controller;


import com.huimv.video.entity.Camera;
import com.huimv.video.entity.vo.CameraListVo;
import com.huimv.video.entity.vo.CameraListsVo;
import com.huimv.video.service.ICameraService;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @author astupidcoder
 * @since 2021-09-13
 */
@RestController
@RequestMapping("/camera")
public class CameraController {
    @Autowired
    private ICameraService cameraService;



    @PostMapping("/list")
    public Result list(@RequestBody CameraListVo cameraListVo){
        return   cameraService.listPage(cameraListVo);
    }

    @PostMapping("/add")
    public Result add(@RequestBody Camera camera){

        if (camera == null){
            return new Result(ResultCode.FAIL,"添加失败");
        }

        return    cameraService.add(camera);

    }

    @PostMapping("/update")
    public Result update(@RequestBody Camera camera){
        return   cameraService.updates(camera);

    }

    @GetMapping("/remove")
    public Result remove(@RequestParam(value = "ids") List<Integer> ids){
        cameraService.removeByIds(ids);
        return new Result(ResultCode.SUCCESS,"删除成功");
    }


    @PostMapping("/getCameraDetails")
    private Result getCameraDetails(@RequestBody CameraListsVo cameraListsVo){

        List list =  cameraService.getCameraDetails(cameraListsVo);
        return new Result(ResultCode.SUCCESS,list);
    }

    @GetMapping("/updateStatus")
    private Result updateStatus(@RequestParam(value = "id")Integer id){

        return  cameraService.updateStatus(id);
    }



    @RequestMapping("/getByAreaId")
    private Result getByAreaId(Integer areaId, HttpServletRequest request){

        List list = cameraService.getByAreaId(areaId);
        return new Result(ResultCode.SUCCESS,list);
    }

}
